SystemOrganization addCategory: #SONiklasBContest!

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:07'!
find0to4SingletonFromBit: suggestedBit max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	"We can have 0 (iff baseSum=0), 2, 4"
	
	| split nextBit nextMask sum2 |
	suggestedBit > max ifTrue: [^{}].
	nextBit := baseSum = 0
		ifTrue: [suggestedBit]
		ifFalse: [baseSum bitAnd: baseSum negated].
	(baseMask bitAnd: nextBit) = 0 ifFalse: [^self find0to4SingletonFromBit: nextBit * 2 max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum].
	nextMask := nextBit + baseMask.
	split := BinarySplit split: self withMask: nextMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	split size1 odd
		ifTrue:
			[^(self find1to3SingletonMax: max baseMask: nextMask baseValue: baseValue baseSum: split sum1)
			, (self find1to3SingletonMax: max baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)].
	^(split doesPreserveBaseSum: baseSum)
		 ifTrue:
			["Cannot decide if (0,4) or (0,2), try another bit"
			self find0to4SingletonFromBit: nextBit * 2 max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum]
		ifFalse:
			[(self find2SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1)
			, (self find2SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 22:00'!
find0to4SingletonMax: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| nextMask nextBit |
	nextMask := baseMask + 1 bitOr: baseMask.
	nextBit := nextMask - baseMask.
	^self find0to4SingletonFromBit: nextBit max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:08'!
find0to6SingletonFromBit: suggestedBit max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	"We can have 0 (iff baseSum=0), 2, 4 or 6 singletons..."
	
	| split nextBit nextMask sum2 |
	suggestedBit > max ifTrue: [^{}].
	nextBit := baseSum = 0
		ifTrue: [suggestedBit]
		ifFalse: [baseSum bitAnd: baseSum negated].
	(baseMask bitAnd: nextBit) = 0 ifFalse: [^self find0to6SingletonFromBit: nextBit * 2 max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum].
	nextMask := nextBit + baseMask.
	split := BinarySplit split: self withMask: nextMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	^(split doesPreserveBaseSum: baseSum)
		 ifTrue:
			[split size1 odd
				ifTrue:
					[(self find1to5SingletonMax: max baseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find1to5SingletonMax: max baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]
				ifFalse: [self find0to6SingletonFromBit: nextBit * 2 max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum]]
		ifFalse:
			[split size1 odd
				ifTrue:
					[(self find1to5SingletonMax: max baseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find1to5SingletonMax: max baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]
				ifFalse:
					[(self find0to4SingletonMax: max baseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find0to4SingletonMax: max baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 22:00'!
find0to6SingletonMax: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| nextMask nextBit |
	nextMask := baseMask + 1 bitOr: baseMask.
	nextBit := nextMask - baseMask.
	^self find0to6SingletonFromBit: nextBit max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:06'!
find1Singleton
	^self find1SingletonBaseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:06'!
find1SingletonBaseMask: baseMask baseValue: baseValue baseSum: baseSum
	^{baseSum}! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 22:38'!
find1to3SingletonMax: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	^(self occurrencesOf: baseSum) = 1
		ifTrue: [{baseSum}]
		ifFalse: [self find3SingletonBaseMask: baseMask baseValue: baseValue baseSum: baseSum]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:08'!
find1to5SingletonFromBit: nextBit max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	"We can have 1,3 or 5 singletons..."
	
	| split nextMask sum2 |
	nextBit > max ifTrue: [^{baseSum}].
	(baseMask bitAnd: nextBit) = 0 ifFalse: [^self find1to5SingletonFromBit: nextBit * 2 max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum].
	nextMask := nextBit + baseMask.
	split := BinarySplit split: self withMask: nextMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	^(split doesPreserveBaseSum: baseSum)
		 ifTrue:
			[self find1to5SingletonFromBit: nextBit * 2 max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum]
		ifFalse:
			[split size1 odd
				ifTrue:
					[(self find1to3SingletonMax: max baseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find0to4SingletonMax: max baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]
				ifFalse:
					[(self find0to4SingletonMax: max baseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find1to3SingletonMax: max baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 22:00'!
find1to5SingletonMax: max baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| nextMask nextBit |
	nextMask := baseMask + 1 bitOr: baseMask.
	nextBit := nextMask - baseMask.
	^self find1to5SingletonFromBit: nextBit max: max baseMask: baseMask baseValue: baseValue baseSum: baseSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:03'!
find2Singleton
	^self find2SingletonBaseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:00'!
find2SingletonBaseMask: baseMask baseValue: baseValue baseSum: baseSum
	| lowestBit split sum2 |
	lowestBit := baseSum bitAnd: baseSum negated.
	split := BinarySplit split: self withMask: lowestBit + baseMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	^{split sum1. sum2}! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 18:25'!
find3Singleton
	^self find3SingletonBaseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:04'!
find3SingletonBaseMask: baseMask baseValue: baseValue baseSum: baseSum
	| split nextBit nextMask sum2 |
	nextMask := baseMask + 1 bitOr: baseMask.
	nextBit := nextMask - baseMask.
	split := BinarySplit split: self withMask: nextMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	^split size1 even
		ifTrue: [split sum1 = 0
			ifTrue: [self find3SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2]
			ifFalse:
				[(self find2SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1)
				, {sum2}]]
		ifFalse: [sum2 = 0
			ifTrue: [self find3SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1]
			ifFalse:
				[{split sum1}
				, (self find2SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 21:02'!
find4Singleton
	^self find4SingletonFromBit: 1 baseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:08'!
find4SingletonFromBit: suggestedBit baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| split nextBit nextMask sum2 |
	nextBit := baseSum = 0
		ifTrue: [suggestedBit]
		ifFalse: [baseSum bitAnd: baseSum negated].
	nextMask := baseMask + nextBit.
	split := BinarySplit split: self withMask: nextMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	split size1 odd
		ifTrue: [^(self occurrencesOf: split sum1) = 1
			ifTrue:
				[{split sum1}
				, (self find3SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]
			ifFalse:
				[(self find3SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1)
				, {sum2}]].
	"This can happen only when baseSum = 0"
	(split doesPreserveBaseSum: baseSum)
		ifFalse:
			[^(self find2SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1)
			, (self find2SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)].
	"Cannot decide if (0,4) or (4,0), try another bit"
	^self find4SingletonFromBit: nextBit * 2 baseMask: baseMask baseValue: baseValue baseSum: baseSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 21:02'!
find5Singleton
	^self find5SingletonFromBit: 1 baseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/18/2012 23:08'!
find5SingletonFromBit: nextBit baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| split nextMask sum2 |
	nextMask := baseMask + nextBit.
	split := BinarySplit split: self withMask: nextMask value: baseValue.
	sum2 := baseSum bitXor: split sum1.
	(split doesPreserveBaseSum: baseSum)
		 ifTrue:
			["Either (0,5) or (2,3) if xor(3)=0, or (4,1) if xor(1)=0"
			split size1 even
				ifTrue: [split sum1 = 0
					ifTrue: ["(0,5) or (4,1) - cannot decide"
						^self find5SingletonFromBit: nextBit * 2 baseMask: baseMask baseValue: baseValue baseSum: baseSum]
					ifFalse: ["(2,3) or (4,1) handled below"]]
				ifFalse: [sum2 = 0
					ifTrue: ["(5,0) or (1,4) - cannot decide"
						^self find5SingletonFromBit: nextBit * 2 baseMask: baseMask baseValue: baseValue baseSum: baseSum]
					ifFalse: ["(3,2) or (1,4) handled below"]]].
	"Either (1,4) or (3,2) "
	^split size1 odd
		ifTrue:
			[((self occurrencesOf: split sum1) = 1 and: [(split sum1 bitAnd: nextMask) = baseValue])
				ifTrue:
					[{split sum1}
					, (self find4SingletonFromBit: nextBit * 2 baseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]
				ifFalse:
					[(self find3SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find2SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]]
		ifFalse:
			[((self occurrencesOf: sum2) = 1 and: [(sum2 bitAnd: nextMask) = (nextBit + baseValue)])
				ifTrue:
					[(self find4SingletonFromBit: nextBit * 2 baseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, {sum2}]
				ifFalse:
					[(self find2SingletonBaseMask: nextMask baseValue: baseValue baseSum: split sum1)
					, (self find3SingletonBaseMask: nextMask baseValue: nextBit + baseValue baseSum: sum2)]]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:03'!
xorSum
	^self inject: 0 into: [:sum :element | element bitXor: sum]! !

TestCase subclass: #TestSONiklasBContest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SONiklasBContest'!

!TestSONiklasBContest methodsFor: 'testing' stamp: 'nice 8/18/2012 21:16'!
test4bitsCombinations
	"TestSONiklasBContest new test4bitsCombinations"
	| numbers |
	numbers := (0 to: 15) asArray.
	4 timesRepeat: [
		numbers := numbers shuffled.
		0 to: 15 do: [:nPairs |
			| stream pairs nSingMax allSings |
			nSingMax := numbers size - nPairs min: 6.
			stream := numbers readStream.
			pairs := stream next: nPairs.
			allSings := stream next: nSingMax.
			0 to: nSingMax do: [:nSing |
				| singletons sequence |
				singletons := allSings first: nSing.
				sequence :=  (pairs , pairs , singletons) shuffled.
				nSing even
					ifTrue: [
						self
							assert: (sequence find0to6SingletonMax: 15 baseMask: 0 baseValue: 0 baseSum: sequence xorSum) sorted
							equals: singletons sorted]
					ifFalse: [
						self
							assert: (sequence find1to5SingletonMax: 15 baseMask: 0 baseValue: 0 baseSum: sequence xorSum) sorted
							equals: singletons sorted]]]].! !

!TestSONiklasBContest methodsFor: 'testing' stamp: 'nice 8/18/2012 19:00'!
test4bitsCombinationsKnowSingletonSize
	"TestSONiklasBContest new test4bitsCombinationsKnowSingletonSize"
	| numbers |
	numbers := (0 to: 15) asArray.
	20 timesRepeat: [
		numbers := numbers shuffled.
		0 to: 15 do: [:nPairs |
			| stream pairs nSingMax allSings |
			nSingMax := numbers size - nPairs min: 5.
			stream := numbers readStream.
			pairs := stream next: nPairs.
			allSings := stream next: nSingMax.
			1 to: nSingMax do: [:nSing |
				| singletons sequence |
				singletons := allSings first: nSing.
				sequence :=  (pairs , pairs , singletons) shuffled.
				nSing = 1 ifTrue: [
						self
							assert: sequence find1Singleton sorted
							equals: singletons sorted].
				nSing = 2 ifTrue: [
						self
							assert: sequence find2Singleton sorted
							equals: singletons sorted].
				nSing = 3 ifTrue: [
						self
							assert: sequence find3Singleton sorted
							equals: singletons sorted].
				nSing = 4 ifTrue: [
						self
							assert: sequence find4Singleton sorted
							equals: singletons sorted].
				nSing = 5 ifTrue: [
						self
							assert: sequence find5Singleton sorted
							equals: singletons sorted]]]].! !

!TestSONiklasBContest methodsFor: 'testing' stamp: 'nice 8/18/2012 18:42'!
testSingletonOfKnownSize

	self assert: {0. 3. 5. 2. 5. 4. 3. 0. 2.} find1Singleton = {4}.
	
	self assert: {0. 1. 1. 3. 5. 6. 2. 6. 4. 3. 0. 2.} find2Singleton sorted = {4. 5}.
	
	self assert: {0. 1. 3. 5. 6. 2. 6. 4. 3. 0. 2.} find3Singleton sorted = {1. 4. 5}.
	self assert: {0. 3. 5.} find3Singleton sorted = {0. 3. 5.}.
	
	self assert: {9. 10. 5. 6. 32. 32} find4Singleton sorted = {5. 6. 9. 10.}.
	
	self assert: {0. 1. 3. 5. 9. 6. 2. 6. 4. 3. 0. 2.} find4Singleton  sorted = {1. 4. 5. 9.}.
	
	self assert: {0. 1. 12. 3. 5. 9. 6. 2. 6. 4. 3. 0. 2.} find5Singleton sorted = {1. 4. 5. 9. 12.}.! !

Object subclass: #BinarySplit
	instanceVariableNames: 'sum1 size1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SONiklasBContest'!

!BinarySplit class methodsFor: 'instance creation' stamp: 'nice 8/18/2012 22:57'!
split: aSequence withMask: aMask value: value
	^self new split: aSequence withMask: aMask value: value! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/18/2012 23:07'!
doesPreserveBaseSum: baseSum
        ^sum1 = 0 or: [sum1 = baseSum]! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:19'!
size1
        ^size1! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/18/2012 22:57'!
split: aSequence withMask: aMask value: value
        sum1 := size1 := 0.
        aSequence do: [:element |
	    (element bitAnd: aMask) = value
                ifTrue:
                    [sum1 := sum1 bitXor: element.
                    size1 := size1 + 1]].! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:19'!
sum1
        ^sum1! !
